// Wemos D1r2 + DHT21 + LCD
// it can 
// - show WiFi status, time, H and T from DHT on LCD
// - set time by buttons
// - connect to wifi wpa point
// - synchronize time from remote http host GET
// - show local HTTP page with H and T 
// - http://ip/ - all
// - http://ip/h -  humidity float
// - http://ip/t - themperature float
// - http://ip/gpio16/0 - gpio16 OFF
// - http://ip/gpio16/1 - gpio16 ON
// - http://ip/gpio16/2 - gpio16 not set - controlled by humidity level
// - send parameters via HTTP GET to another server
// - pin 16 (D0) is ON then humidity>60%, use relay module for fan ON
// used wemosD1 manual: https://geekelectronics.org/arduino/wemos-d1-r2-na-esp8266-ndash-pervoe-znakomstvo.html
#include <LiquidCrystal.h>
#include "DHT.h"
#include <Ticker.h>
#include <ESP8266WiFi.h>

// SSIDs
const char* ssids[3] = { "poin1","poin2","point3" };
// SSID's passwords
const char* passwds[3] = { "password1","password3","password3" };
// you can try to set static IP
//IPAddress ip(192, 168, 1, xx); // where xx is the desired IP Address
//IPAddress gateway(192, 168, 1, 254); // set gateway to match your wifi network
//IPAddress subnet(255, 255, 255, 0); // set subnet mask to match your wifi network

// remote host 
const char* host = "lisolog.atwebpages.com";
// remote page for sync time
String url = "/gpio/themp-graph.php?act=Hi";
// remote page to send themp
String url2 = "/gpio/themp.php?act=save&sens_id=7&p=3333&val=";
// remote page to send H
String url3 = "/gpio/themp.php?act=save&sens_id=8&p=3333&val=";
// example url to send values
//   http://site.name/gpio/themp.php?act=save&sens_id=9&val=15&p=pass
// MAX Humidity for fan on pin 16 (D0)
float h_max_comfort=60;
// Create an instance of the server
// specify the port to listen on as an argument
WiFiServer server(80);
 Ticker dht_get;
 Ticker tim;
 Ticker key_r;

// RS, E, DB4, DB5, DB6, DB7
// simple LCD
// LiquidCrystal lcd(12, 13, 16, 5, 4, 0);
// keypad LCD shield:
LiquidCrystal lcd(12, 13, 4, 0, 2, 14);  //15-12
float h = 0;  
float t = 0;   
float t1 =0;
int hour=0; 
int minu=0;
int secu=0;
int clnts=0;
int point=0;
float refr_cnt=883;
String datas="Init";
String selector=" ";
#define DHTPIN 5
#define DHTTYPE DHT21
DHT dht(DHTPIN, DHTTYPE);
bool dht_get_flag = false;
bool tm_flag = false;
bool key_flag = false;
int gpio16 = 2;


void wifi_connect()
{          Serial.print("Trying ");Serial.println(ssids[point]);
           WiFi.begin(ssids[point], passwds[point]); // samotný proces pripojeni k siti
          int wfcnt=0;
          while (WiFi.status() != WL_CONNECTED) { // dokud není pripojeno 
            if(wfcnt>15) {     
              lcd.setCursor(2, 0);      
              lcd.print("er ");    
               dht_get_flag = false; 
               if(point<2) point++; else point=0;
               return; 
              }                  
              delay(500);     wfcnt++;                      // cekej 500ms
              Serial.print(".");                    // vypis tecku
          }
          Serial.println("");                     
          Serial.println("WiFi connected");      
          // zapnni sever
          server.begin();
          Serial.println("Server started");
          Serial.print("Wemos D1 IP: ");
           Serial.println(WiFi.localIP());
      lcd.setCursor(2, 0);      
      lcd.print("ok");   
      lcd.setCursor(0, 1);      
      lcd.print("                    ");        
      lcd.setCursor(0, 1);      
      lcd.print(WiFi.localIP());      
      delay(2000);
      lcd.setCursor(0, 1);      
      lcd.print(datas);          
}

void dht_read()
{   
      h = dht.readHumidity(); 
      t = dht.readTemperature();
  if (isnan(t) || isnan(h)) { 
      lcd.setCursor(0, 1);      
      datas ="DHT not found!   "; 
      lcd.print(datas);     
  } 
  else { 
   //   lcd.clear();
      datas =  "B:";
      datas +=round(h);
      datas += "% t:";
      datas += t;//t1;
      datas += "*C";
      lcd.setCursor(0, 1);      
      lcd.print("                    ");        
      lcd.setCursor(0, 1);      
      lcd.print(datas);     
      Serial.print("T: "); 
      Serial.print(t); 
      Serial.print("H: "); 
      Serial.print(h);       
    } 
}

void dht_get_finc()
{
      lcd.setCursor(4, 0); 
      lcd.print("D");     
      dht_read();
    if((WiFi.status() == WL_CONNECTED))
    {  
      //  Serial.print("connecting to ");
      // Serial.println(host);  
      // Use WiFiClient class to create TCP connections
        WiFiClient client;
        const int httpPort = 80;
        lcd.setCursor(5, 0);   lcd.print("t");
        if (client.connect(host, 80))
        {       
            client.print(String("GET ") + url2 + t + " HTTP/1.1\r\n" +
                  "Host: " + host + "\r\n" + 
               "Connection: close\r\n\r\n");               
                String line = "";
          while (client.connected())
            if (client.available())
            {   line = client.readStringUntil('\n');
                  if(line.indexOf('saved')>0)  Serial.println(line);
                 }
              client.stop();
        }
          else     {     Serial.println("connection failed!]");      client.stop();     }            
          lcd.setCursor(5, 0);   lcd.print("h");
          if (client.connect(host, 80))
          {       
            client.print(String("GET ") + url3 + h + " HTTP/1.1\r\n" +
               "Host: " + host + "\r\n" + 
               "Connection: close\r\n\r\n");               
              String line = "";
            while (client.connected())
              if (client.available())
              {   line = client.readStringUntil('\n');
                  if(line.indexOf('saved')>0)  Serial.println(line);
                 }
            client.stop();
          }
          else     {     Serial.println("connection failed!]");      client.stop();     }

          lcd.setCursor(5, 0);   lcd.print("T");
          if (client.connect(host, 80))
          {                   
          // This will send the request to the server
            client.print(String("GET ") + url + " HTTP/1.1\r\n" +
               "Host: " + host + "\r\n" + 
               "Connection: close\r\n\r\n");
          // Read all the lines of the reply from server and print them to Serial
            String line = "";
            while (client.connected())
            {
            if (client.available())
              {
                line = client.readStringUntil('\n');
                if(line.indexOf('now')>0)
                {
                    String st= line.substring(3,5);
                    hour = st.toInt();
                    st= line.substring(5,7);
                    minu = st.toInt();
                    st= line.substring(7,9);
                    secu = st.toInt();          
                    Serial.println(line);   
                }
              }
            }
            client.stop();
            //    Serial.println("disconnect");
            }
            else     {     Serial.println("connection failed!]");      client.stop();     }
            /////////WiFi.disconnect();
    }
    dht_get_flag = false;
      lcd.setCursor(4, 0); 
      lcd.print(" ");     
}

void tm_show_finc()
{
      lcd.setCursor(5, 0);      
      lcd.print("T");      
    secu=secu+30;
    if(secu>59) 
    { secu=0; minu++; }
    if(minu>59) 
    { minu=0; hour++; }
    if(hour>23) hour=0;
      lcd.setCursor(10, 0);      
      lcd.print("        ");    
      lcd.setCursor(10, 0);   
      if(hour<10) lcd.print("0");  
      lcd.print(hour); 
      lcd.print(":");
      if(minu<10) lcd.print("0");  
      lcd.print(minu); 
//      lcd.print(":");
//      if(secu<10) lcd.print("0");  
//      lcd.print(secu); 
      Serial.print(hour);
      Serial.print(minu);
      Serial.print(secu);
      Serial.print("-");
    if(WiFi.status() != WL_CONNECTED) {  wifi_connect();} else 
      {   lcd.setCursor(2, 0);  lcd.print("ok"); }
      dht_read();
      if(h>h_max_comfort&&gpio16 != 0)  digitalWrite(16, HIGH); 
      if(h<=h_max_comfort&&gpio16 != 1)  digitalWrite(16, LOW); 
   
      lcd.print(" ");         
       lcd.setCursor(5, 0); 
       tm_flag=false;
}
void key_reader()
{
        int x; 
      x = analogRead (A0); 
      lcd.setCursor(5,0); 
      lcd.print (" "); 
      lcd.setCursor(5,0);     
      if (x < 60) {   // RIGHT
          lcd.print (">"); 
        } 
        else if (x < 250) {   // UP
          if (selector=="M") 
            {       minu++;  tm_show_finc();      }
          if (selector=="H") 
            {        hour++;  tm_show_finc();      }    
  
       } 
       else if (x < 500){   // DOWN
           if (selector=="M") 
            {       minu--;  tm_show_finc();      }
            if (selector=="H") 
            {        hour--;  tm_show_finc();      }     
            if (selector=="I") 
             {    
                  lcd.setCursor(0, 1);      
                   lcd.print("                ");    
                   lcd.setCursor(0, 1);      
                  lcd.print(WiFi.localIP());               
                  delay(5000);
                  lcd.setCursor(0, 1);      
                  lcd.print(datas);                      
            }     
               
        } 
      else if (x < 790){   // LEFT
            if (selector=="I") { selector=" "; } else
            if (selector=="M") { selector="I";} else
            if (selector=="H") { selector="M";} else
            if (selector==" ") selector="H";    
          lcd.setCursor(6,0); 
          lcd.print (selector);     
          lcd.setCursor(5,0);     
        } 
       else if (x < 1023){   
          lcd.print ("S");   // it not works on my shield
        }        
        key_flag = false;
}


void http_server()
{
  // kontroluj zda se nekdo pripojil
  WiFiClient client = server.available();
  if (!client) {     return;                 }
  
  // zobraz z IP adresu za jake prisel pozadavek
  Serial.print("ClientIP: ");
  Serial.println(client.remoteIP());
  if(clnts<9) clnts++; else clnts=0;
          lcd.setCursor(7,0); 
          lcd.print (clnts);   
  
     
  while(!client.available()){ //dokud neni client dostupny cekej
    delay(1);
    }  
      // Read the first line of the request
      String req = client.readStringUntil('\r');
      Serial.println(req);
      client.flush();    
        // Prepare the response
      String s = "HTTP/1.1 200 OK\r\nContent-Type: text/html\r\n\r\n<!DOCTYPE HTML>\r\n<html>\r\n";
      s += "H:";
      s += h;
      s += "%<br />t:";
      s += t;
      s += "*C</html>\n";    
          if (req.indexOf("/h") != -1) client.print(h);
          else if (req.indexOf("/t") != -1) client.print(t);
          else if (req.indexOf("/gpio16/0") != -1) { gpio16=0; digitalWrite(16, LOW); }
          else if (req.indexOf("/gpio16/1") != -1) { gpio16=1; digitalWrite(16, HIGH); }
          else if (req.indexOf("/gpio16/2") != -1) { gpio16=2; digitalWrite(16, LOW); }
          else {  client.print(s);   }      
  //client.print(s); // posli odpoved 

}

void key_event()
{
  if(!tm_flag && !dht_get_flag) key_flag = true;
}


void dht_get_event()
{
  if(!tm_flag) dht_get_flag = true;
}

void tm_event()
{
  tm_flag=true;
}
 
void setup() 
{
    Serial.begin(9600); 
    WiFi.softAPdisconnect();
    WiFi.disconnect();
 //   WiFi.mode(WIFI_STA);
    pinMode(16, OUTPUT);  
    digitalWrite(16, LOW); 
    lcd.begin(16, 2);
    lcd.print("WF.....");
    lcd.setCursor(0, 1);
    Serial.println("System inits");
    lcd.print("System inits");
    // timers in sec:
       dht_get.attach(297, dht_get_event);
       tim.attach(30.0, tm_event);
       key_r.attach(0.3, key_event);  
       dht.begin(); 
    //   wifi_connect();
       dht_get_finc();
 }
 
void loop() 
{
     if (dht_get_flag) dht_get_finc();
     if (tm_flag) tm_show_finc(); 
     if (key_flag) key_reader(); 
     if(!tm_flag && !dht_get_flag) http_server();
}

